// TrackBar.h: interface for the CTrackBar class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRACKBAR_H__6F3068C3_047D_48EF_97BE_AE02C424BCFE__INCLUDED_)
#define AFX_TRACKBAR_H__6F3068C3_047D_48EF_97BE_AE02C424BCFE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WindowVirt.h"

typedef CWinTraits<WS_CHILD | WS_VISIBLE> TrackBarTraits;

class CTrackBar  : public CWindowImpl<CTrackBar,CWindowVirt,TrackBarTraits>
{
public:
	CTrackBar();
    virtual ~CTrackBar();

    // To avoid having to create our own custom window class, follow
    // what WTL did and define GetWndClassName() together with Create().
	HWND Create(HWND hWndParent, RECT& rect, LPCTSTR szWindowName = NULL,
			DWORD dwStyle = 0, DWORD dwExStyle = 0,
			UINT nID = 0U, LPVOID lpCreateParam = NULL)
	{
		return CWindow::Create(GetWndClassName(), hWndParent, rect, szWindowName,
                               dwStyle | GetWndStyle(dwStyle),
                               dwExStyle | GetWndExStyle(dwExStyle),
                               nID, lpCreateParam);
	}

    static LPCTSTR GetWndClassName()
    {
        return TRACKBAR_CLASS;
    }

    BEGIN_MSG_MAP(CTrackBar)
    END_MSG_MAP()

    void SetRange(int min, int max)
    {
         // Set the user-requested range.
        ::SendMessage ( m_hWnd
		              , TBM_SETRANGE
                      , (WPARAM)FALSE
                      , (LPARAM)MAKELONG(min,max)
                      );
    }

};

#endif // !defined(AFX_TRACKBAR_H__6F3068C3_047D_48EF_97BE_AE02C424BCFE__INCLUDED_)
