// PanViewer.cpp : main source file for PanViewer.exe
//

#include "stdafx.h"

#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>
#include <atlctrlw.h>


#include "resource.h"

#include "PanViewerView.h"
#include "aboutdlg.h"
#include "MainFrm.h"
#include "UnregisterServer.h"

extern "C" {
CAppModule _Module;
};

int Run(LPTSTR lpstrCmdLine = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

    int nNumArgs;

	CMainFrame wndMain;
    RECT r = { 50, 50, 400, 400};
    PWSTR* ppArgv = CommandLineToArgvW(GetCommandLineW(), &nNumArgs);

	if(wndMain.CreateEx(NULL,r) == NULL)
	{
		ATLTRACE(_T("Main window creation failed!\n"));
		return 0;
	}

	wndMain.ShowWindow(nCmdShow);

    if (nNumArgs == 2) {
        BOOL bFlag = false;
        LPTSTR theFile;

#ifdef UNICODE
        theFile = ppArgv[1];
#else
        theFile = lpstrCmdLine;
#endif

        // remove quotes around filename
        PathUnquoteSpaces(theFile);
        LPTSTR ext = PathFindExtension(theFile);

        if ( StrCmpI(ext, TEXT(".pan")) == 0 ) {
            // it's a settings file.
            wndMain.OpenDoc(theFile);
        } else {
            CLSID   clsid;
            LPTSTR  effectName;
            LPTSTR  progID;

            if (SUCCEEDED(BinaryToCLSID(theFile, &clsid, effectName, progID))) {
                wndMain.OpenComponent(clsid, effectName, progID);
            }
        }
    }
    GlobalFree(ppArgv);

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

#if (_WIN32_IE >= 0x0300)
	INITCOMMONCONTROLSEX iccx;
	iccx.dwSize = sizeof(iccx);
	iccx.dwICC = ICC_COOL_CLASSES | ICC_BAR_CLASSES;
	BOOL bRet = ::InitCommonControlsEx(&iccx);
	bRet;
	ATLASSERT(bRet);
#else
	::InitCommonControls();
#endif

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));


	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}
